//    IPS Java Speech Database
//    (c) Copyright 2011
//    Institute of Phonetics and Speech Processing,
//    Ludwig-Maximilians-University, Munich, Germany
//
//
//    This file is part of IPS Java Speech Database
//
//
//    IPS Java Speech Database is free software: you can redistribute it and/or modify
//    it under the terms of the GNU Lesser General Public License as published by
//    the Free Software Foundation, version 3 of the License.
//
//    IPS Java Speech Database is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU Lesser General Public License for more details.
//
//    You should have received a copy of the GNU Lesser General Public License
//    along with IPS Java Speech Database.  If not, see <http://www.gnu.org/licenses/>.

package ipsk.db.speech;

import java.io.Serializable;
import java.util.HashSet;
import java.util.Set;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.JoinTable;
import javax.persistence.ManyToMany;
import javax.persistence.OneToMany;
import javax.persistence.Table;

@Entity
@Table(name = "annotation_project")

public class AnnotationProject implements Serializable {
	protected int annotationProjectId;
	protected String name;
	protected String description;
	protected Set<Account> admins = new HashSet<Account>(0);
	protected Set<AnnotationSession> sessions = new HashSet<AnnotationSession>(0);//OneToMany
	
	/** default constructor */
	public AnnotationProject(){
	}
	
	/** minimal constructor */
	public AnnotationProject(int annotationProjectId){
		this.annotationProjectId = annotationProjectId;
	}
	
	public AnnotationProject(AnnotationProject source){
		this();
		merge(source);
	}

	protected void merge(AnnotationProject source) {
		this.annotationProjectId = source.annotationProjectId;
		this.name = source.name;
		this.description = source.description;
		this.admins = source.admins;
		this.sessions = source.sessions;
	}
	public String toString(){
		String name = "ipsk.db.speech.AnnotationProject(";
		if(annotationProjectId==0){
			name = name.concat("-");
		} else {
			name = name.concat(Integer.toString(annotationProjectId));
		}
		name = name.concat(":" + name + ")");
		return name;
	}

}
